/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.****

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.4
        Device            :  PIC18F27K42
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/



#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "Fontes_for_OLED.h"
#include "OLED_SSD1306_I2C_Hardw_18Fx7K42_2021-03.h"

#pragma warning disable 520  
#pragma warning disable 1510 
#pragma warning disable 759
#pragma warning disable  2053


#define _XTAL_FREQ 64000000  
#define FOSC      64000000              // Fosc=64MHz
#define FCY       (FOSC/4)              // Fcy=16MHz
#define BR        19200                // Baud Rate  UART Speed !!!!
#define BRG       ((FCY/BR)-1)          // brgs=1

#define Delay_4sec() {__delay_ms(2000); __delay_ms(2000);}
#define ADCRES  3.6/4096.0   // ADC  per volt =3.6/4096 , vcc/adc , 2^12

//#define OLED_ADDR 0x3C   // adresse 7 bits !
#define TAB 9
#define CR 13
#define LF 10
#define Beep 7



 uint8_t tmp[40];
 uint8_t TEXTE[80];
 uint8_t *txt;
 uint8_t *p1;
 uint8_t *p2;

uint8_t CRam1[80];
long l;
uint16_t i,j,k;
/*
 extern volatile uint8_t c1;
 extern volatile uint8_t Flag_Buffer1;
 extern volatile uint8_t Buffer1[]=0;
 extern volatile uint16_t Index1;
 extern volatile uint16_t i1; 
 * */

 volatile uint8_t c1;
 volatile uint8_t Flag_Buffer1;
 volatile uint8_t Buffer1[];
 volatile uint16_t Index1;
 volatile uint16_t i1; 
 
 

char Buffer2[90];
volatile uint8_t c2,cx;
//volatile uint8_t Flag_Buffer1;
volatile  uint16_t CptErr;
//volatile char c1;

 uint8_t  Table[10];
 uint8_t ADCstr[7];
 uint8_t Tempstr[5];
float F0,F1;


 
 i2c1_address_t Addr=OLED_ADDR;
adc_result_t pot_value;   
//uint16_t pot_value = 0;
uint16_t temp = 0;
uint16_t time_out=20;

struct {
unsigned b0:1, b1:1, b2:1, b3:1, b4:1, b5:1, b6:1, b7:1;
} Drapeaux;


#define With_RTC_DS3231
#define DS3231_ADDR 0x68     // 7 bits adresse , sinon  0xD0  sur 8 bits
#include "RTC_DS3231_2021-03.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"

#define SQA_Dir TRISAbits.TRISA3   
#define SQA     LATAbits.LATA3

void PrintChar(uint8_t txData)
{
    while(0 == PIR3bits.U1TXIF)
    {
    }
    U1TXB = txData;    // Write the data byte to the USART.
}



void CRLF1(void)
{
    while(PIR3bits.U1TXIF==0);
    U1TXB=13;
    while(PIR3bits.U1TXIF==0);
    U1TXB=10;
} 


 void Print (char * T1)
 {
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0) continue;
     U1TXB=*(T1);
    T1++;
   }
}
  
  void CPrint (const char * T1)
 {
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0) continue;
     U1TXB=*(T1);
    T1++;
   }
}

void RAZ_Buffer1(void)
{ 
    for (i1=0;i1<sizeof(Buffer1);i1++) Buffer1[i1]=0;
    Flag_Buffer1=0;
   // PIE3bits.U1IE  = 1;       // int uart1 enabled
  //  PIE3bits.U1RXIE=1;
      Flag_Buffer1 =0 ;
        U1RXEN=1;
        U1ERRIR = 0x00;
        U1ERRIE = 0x00;
        if (U1RXIF==1)   c1=U1RXB ;
        c1=0;
        Buffer1[0]=0;
        i1=0;
        Index1=0;
        U1RXIE=1;    
}

void RAZ_Buffer2(void)
{ int i=0;
    for (i=0;i<sizeof(Buffer2);i++) Buffer2[i]=0;
}

// https://microchipdeveloper.com/xc8:console-printing
 void putch( char donnee)
 {
 while (!PIR3bits.U1TXIF)   continue;
    U1TXB=  donnee;                     // send one character
    PIR3bits.U1TXIF=0;
}
  
// rev 22/03/2021 
bool I2C1_DevicePresent(int16_t address)
{
  I2C1PIRbits.PCIF = 0;                // clear STOP bit flag
  I2C1ADB1 = address;                  // load slave addr and R/W
  I2C1CNT = 0;
  I2C1CON0bits.S = 1;                  // send START + addr
  while (I2C1PIRbits.PCIF == 0);       // wait for STOP                     
  return !I2C1CON1bits.ACKSTAT;
} 

// Conversion du code BCD en chiffre decimal
 uint8_t  Bcd2Dec( uint8_t  val)
{
 return ( (val>>4*10) + (val%16) );
}

 void BCD_To_Ascii( uint8_t  cc, uint8_t * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }

uint8_t Dec2Bcd(uint8_t n)
{
 return (n / 10 * 16 +  n % 10);
}

void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();
  
    CRLF1();
    IO_RB1_SetDigitalInput() ;   // choix LCD OLED inp RB1
    IO_RC0_SetDigitalInput() ;  // RTC force inp  RC0 
    SQA_Dir=0; 
    SQA=0;
    
    CptErr=0;
    CRLF1();
    txt=&TEXTE[0];
   
    
    printf(" Projet MPLABX :_18F27K42_OLED_SSD1306_RTC_UART_ITRX_2021-03\r\n "
            "Compile le %s a %s UTC\r\n avec version XC8 :  %d\r\n", __DATE__, __TIME__, __XC8_VERSION);
    CPrint(" Usage de OLED_SSD1306_I2C_Hardw_18Fx7K42_2021-0316.c  rev 22/03/2021 \r\n");
    CPrint(" Hardware : BASE 18F27K42 \r\n");
    CPrint(" Entree ANA sur RA1 \r\n");
    CPrint(" Sortie NCO1 10Khz sur RA3 \r\n");
    CPrint(" SQA50 synchro Analyser : Sortie sur RC5 \r\n");
    CPrint(" Select OLED 0,96"" 128x32  Jaune/bleu ou Mini-OLED sur I2C1 via Pin RB1 \r\n");   
    CPrint(" RTC DS3231 sur le bus I2C1 RC3=SCL RC4=SDA\r\n"); 
    CPrint(" MAJ RTC via UART1 avec RX Interrupt \r\n"); 
    __delay_ms(2000);
    
     txt=&TEXTE[0];
     *(txt)=0; 
    CRLF1(); 
    CPrint(" Test Presence I2C device (adressage 8 bits)\r\n"); 
     I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted address data is loaded from the I2CxADB0/1 registers.      
    I2C1CON0bits.EN = 1;
     for (i=2; i<=253; i=i+2)
    {
     if (I2C1_DevicePresent(i)) 
     {   
       k=i>>1;
       sprintf(txt," @ decimal #%4u  soit @Device7bits = 0X%02X ",i,k);
       switch (k)
       {
        case 0x27: 
        case 0x28: 
        case 0x29: 
        case 0x2A: 
        // case etc ..   
            strcat(txt,"PCF8574 8bits I/O");// de base + 7 autres
            break; 
        case 0x37:
            strcat(txt,"LCD 2119 2x16cars"); // de base + 7 autres
            break;  
        case 0x38:
        case 0x39:
        case 0x3A:
        case 0x3B:
        // case etc ..                                 
            strcat(txt,"PCF8574A 8bits I/O"); // de base + 7 autres
            break;  
        case 0x3C:
            strcat(txt,"OLED SSD1306");
            break;
        case 0x53:
            strcat(txt,"ADXL345 board");
            break;            
        case 0x57:
            strcat(txt,"EEPROM 512bytes");
            break;
        case 0x68:
            strcat(txt,"RTC DS3231");
            break;
        default:
            strcat(txt,"non recens");        
            break;
       }   
       Print(txt);CRLF1();
     }
    }
   I2C1CON0bits.EN = 0;
   I2C1CON2bits.ABD=1; 
   CRLF1();
      
  
 
    
    INTERRUPT_GlobalInterruptEnable();      // indispensable ! 
  
        
  
    RAZ_Buffer2();
    
  #ifdef With_RTC_DS3231
  CPrint(" #1 Active sortie SQW=1Hz: \r\n");
  CPrint(" GO\r\n");
  // set SQW output  Start oscillateur
  tmp[0]=0x40; // data 
  I2C1_Write1ByteRegister(DS3231_ADDR,0x0E, tmp[0]);
   CPrint(" ok\r\n");
   __delay_ms(100);

    for (i=1;i<32;i++) tmp[i]=0;
    CPrint( " Etat pin RC0 = ");
    putch((PORTC & 0x01)+48);
    CRLF1();
    
   
    if(RTC_Forcee==0)    // RC0 input
    {
     CPrint( " Init RTC Forcee a samedi 02/03/21 18:46:57 via  RC0=0 \r\n");
    tmp[0]=0x00;  //start register
     tmp[1]=0x57;  //second
      tmp[2]=0x16;  //write min
       tmp[3]=0x18; //write hour;
        tmp[4]=0x06;  ///write day of week
         tmp[5]=0x02;    // write date
          tmp[6]=0x03;      // write month
           tmp[7]=0x21;    // write year
            tmp[8]=0x00;
     SQA=1;
     p1=&tmp[0];
     I2C1_WriteNBytes(DS3231_ADDR,p1,8);
     SQA=0;
    }
    __delay_ms(1000);
    CPrint(" RC0=1 donc ,re-Lecture et affichage des 7 Registres DS3231 \r\n");
    j=0;
    do
    {
    CPrint(" Registre #");
    putchar(j+48);
     putchar(9);
    cx=Lecture_Affichage_Registre_DS3231(j,1);
    CRLF1();
    j++;
    }
    while(j<8) ;
    CRLF1();
   Print_Date_Complete();
    __delay_ms(1000);
 
   #else
   CPrint(" Pas de gestion RTC DS3231\r\n");
   #endif
   
    
    CPrint(" Choix du type LCD OLED via etat Pin RB1 =");
    putch((PORTB & 0x02)+48);
    CRLF1();
    if (Choix_OLED_096==1)  // RB1 input=1
    {
       CPrint(" OLED 096"" SSD1306 24mm x 28mm  I2C1 Hardware\r\n");
     } 
     else
     {
         CPrint(" mini-OLED SSD1306 20 x 10mm \r\n");
     }   
    
     CPrint(" 4 lignes de 128/6=21 chars avec fonte 5x8\r\n");
    SQA=1;
    OLED_Init(); // mini OLED ...OK
    SQA=0;
    
    CPrint(" Clear OLED \r\n");
    OLED_Clear();
     __delay_ms(100); //"123456789012345678901")// gabarit !
    sprintf(Buffer2,"Mini OLED SSD1306 I2C");
    Print(Buffer2);  CRLF1();
    OLED_SelectPage(0);   
    OLED_WriteString(Buffer2);
    
    sprintf(Buffer2,"123456789012345678901"); // 21 cars en 6x8
 // sprintf(Buffer2,"1234567890123456"); // 16 cars en 8x8
    OLED_SelectPage(1); 
    OLED_WriteString(Buffer2);
    Print(Buffer2);  CRLF1();
     
    sprintf(Buffer2,"Ligne #03  Page #2   ");
    Print(Buffer2);  CRLF1();
    OLED_SelectPage(2);   
    OLED_WriteString(Buffer2);
    
    sprintf(Buffer2,"Ligne #04  Page #3   ");
    Print(Buffer2);  CRLF1();
    OLED_SelectPage(3);   
    OLED_WriteString(Buffer2);
     
    __delay_ms(2000);
     
  //   goto Strap1;
     
     CRLF1();
     CPrint(" Clear OLED \r\n");
     OLED_Clear();
     CPrint(" Affiche lettres A B C ...Q \r\n");
     CPrint("  Write_Char_At(X en pixel (0 a 127), ligne Y (0 a 3),code ascii char)\r\n");
     Write_Char_At(0,0,'A');
     Write_Char_At(8,1,'B');
     Write_Char_At(16,2,'C');
     Write_Char_At(24,3,'D');
     Write_Char_At(32,3,'E');
     Write_Char_At(40,2,'F');
     Write_Char_At(48,1,'G');
     Write_Char_At(56,0,'H');
     Write_Char_At(56,1,'I');
     Write_Char_At(64,2,'J');
     Write_Char_At(72,3,'K');
     Write_Char_At(80,3,'L');
     Write_Char_At(88,3,'M');
     Write_Char_At(96,2,'N');
     Write_Char_At(104,1,'O');
     Write_Char_At(112,0,'P');
     Write_Char_At(120,1,'Q');
     Delay_4sec();
    
     
     
    CPrint(" Clear OLED \r\n");
    OLED_Clear();
     __delay_ms(1000);
  
          // gabarit     "123456789012345678901"
    sprintf(Buffer2,     "MPLABX XC8 16-03-2021");
    OLED_SelectPage(0); 
    OLED_WriteString(Buffer2);
    
   if (Choix_OLED_096==1) // via etat pin RB1
   {
     sprintf(Buffer2,"OLED 0,96""J/Bleu ");     // 21cars en 6x8
    }
    else
    {
      sprintf(Buffer2, "Mini-OLED SSD13061");
    }  
       
 //   sprintf(Buffer2,"1234567890123456"); // 16 cars en 8x8
    OLED_SelectPage(1); 
    OLED_WriteString(Buffer2);
    Print(Buffer2);
    CRLF1();
     __delay_ms(1000);   
     
    sprintf(Buffer2,  "OLED x=10 y=2"); 
    Print(Buffer2); CRLF1();
    *(Buffer2+4)=0; // OLED seulement
    OLED_ShowStr(10,2,Buffer2,1);
     __delay_ms(1000); 
     
    sprintf(Buffer2,  "OLED x90 y=3"); 
    Print(Buffer2); CRLF1();
    *(Buffer2+4)=0;
    OLED_ShowStr(90,3,Buffer2,2);
    Delay_4sec();

    OLED_Clear();
     __delay_ms(1000);    
    j=0;
    
    OLED_SelectPage(0);
    Buffer2[0]=0;// "123456789012345678901")// gabarit !
    sprintf(Buffer2, "..ZIG-ZAG en Boucle.."); 
    OLED_WriteString(Buffer2);
    Print(Buffer2); CRLF1();
    __delay_ms(1000);   
    OLED_ClearLine(0);
    
  Strap1:  


    CPrint(" IT UART Arme \r\n");
     RAZ_Buffer1();
  
      
     
   while (1)
    {  
     Display_Date_Time(1);
     putch(';');
     Ds3231_Temp_CP(0);
     Print( DS_Temp);
     putch(';');
             
     OLED_SelectPage(0); 
     *(Buffer2)=0;
     strcat(Buffer2,date);
     strcat (Buffer2," ");
     strcat(Buffer2,time);
     OLED_ShowStr(0,0,Buffer2,2);
        
    OLED_ClearLine(1);
    sprintf(Buffer2, "Ball");
    OLED_ShowStr(j,1,Buffer2,2);
      
    OLED_SelectPage(2);
    Buffer2[0]=0; //"123456789012345678901")// gabarit !
    sprintf(Buffer2,"MCU 18F27K42 I2C HW  ");
    OLED_WriteString(Buffer2);
  
    Print(TAB);
        
    //4em ligne (page 3))
    pot_value = ADCC_GetSingleConversion(channel_ANA1);
    F0 = (float) pot_value * ADCRES ;//* 10000;
    OLED_SelectPage(3);
     __delay_ms(20);
                  //"123456789012345678901")// gabarit !
    Buffer2[0]=0; //"EA1=4095 soit 3.600V")// gabarit !
    sprintf(Buffer2,"EA1=%4u soit %2.3fV ",pot_value,F0);
    OLED_WriteString(Buffer2);
    Print(Buffer2);
    CRLF1();
   
    IO_RA4_Toggle();
    
   //_delay_ms(50);
    j++;   
    if (j>95) j=0;  
 
    RAZ_Buffer1();
    __delay_ms(1500);
    
    
    k=0;
    
     if (Flag_Buffer1==1)
    { 
      // CPrint("\r\n Recu : ");
       *(Buffer1+80)=0;
      // Print (Buffer1);
      // CRLF1();
       Flag_Buffer1=0;
       p2=&Buffer1[0];
      #ifdef With_RTC_DS3231
        //U;03;03;21;15;14;03;#
      if (  (*(p2)=='U') && (*(p2+1)==';') && ( *(p2+19)==';') )
      {
        CPrint("\r\n MAJ RTC \r\n");
      //  Print(Buffer1);    CRLF1();
        MAJ_RTC();
        CRLF1();
        p2=0;
      }
      #endif
      if ((*(p2)=='H') && (*(p2+1)=='e') && ( *(p2+2)=='l') && ( *(p2+3)=='p') )
      {
        CPrint("\r\n Help Commandes :\r\n");
        CPrint(" MAJ RTC  \r\n");
        CPrint(" ex: U;03;03;21;15;14;03;#  pour 03 mars 2021 , 15H14  Mercredi \r\n");
        CPrint(" Help \r\n");
        Print(Buffer1);    CRLF1();
        p2=0 ;
      }
      // autre tests ...
     }
   }
}

/*
 End of File
*/
/*
 Mmake[1]: Leaving directory 'C:/MPLABX_Projects/_18F27K42_OLED_SSD1306_2021-03.X
 * 
 * 
 *
 * 
 Projet MPLABX :_18F27K42_OLED_SSD1306_RTC_UART_ITRX_2021-03
 Compile le Mar 20 2021 a 18:27:08 UTC
 avec version XC8 :  2100
 Usage de OLED_SSD1306_I2C_Hardw_18Fx7K<NUL>

 Projet MPLABX :_18F27K42_OLED_SSD1306_RTC_UART_ITRX_2021-03
 Compile le Mar 20 2021 a 18:27:08 UTC
 avec version XC8 :  2100
 Usage de OLED_SSD1306_I2C_Hardw_18Fx7K42_2021-0316.c  rev 20/03/2021 
 Hardware : BASE 18F27K42 
 Entree ANA sur RA1 
 Sortie NCO1 10Khz sur RA3 
 SQA50 synchro Analyser : Sortie sur RC5 
 Select OLED 0,96 128x32  Jaune/bleu ou Mini-OLED sur I2C1 via Pin RB1 
 RTC DS3231 sur le bus I2C1 RC3=SCL RC4=SDA
 MAJ RTC via UART1 avec RX Interrupt 

 Test Presence I2C device (adressage 8 bits)
 @ decimal # 120  soit @Device7bits = 0X3C OLED SSD1306
 @ decimal # 174  soit @Device7bits = 0X57 EEPROM 512bytes
 @ decimal # 208  soit @Device7bits = 0X68 RTC DS3231

 #1 Active sortie SQW=1Hz: 
 GO
 ok
 Etat pin RC0 = 1
 RC0=1 donc ,re-Lecture et affichage des 7 Registres DS3231 
 Registre #0	35	
 Registre #1	27	
 Registre #2	18	
 Registre #3	06	
 Registre #4	20	
 Registre #5	03	
 Registre #6	21	
 Registre #7	00	

Samedi  20 Mars  21 18H27M35S
 Choix du type LCD OLED via etat Pin RB1 =2
 OLED 096 SSD1306 24mm x 28mm  I2C1 Hardware
 4 lignes de 128/6=21 chars avec fonte 5x8
 Clear OLED 
Mini OLED SSD1306 I2C
123456789012345678901
Ligne #03  Page #2   
Ligne #04  Page #3   
 
02/03/21  18H17M23S  ; 17.75C;EA1=1887 soit 1.658V 
U;18;03;21;19;18;04;#
U;18;03;21;19;18;04;#<CR>
 MAJ RTC 
Ecriture DS3231... OK

18/03/21  19H18M00S  ; 17.75C;EA1=1884 soit 1.656V 
18/03/21  19H18M01S  ; 17.75C;EA1=1884 soit 1.656V 
18/03/21  19H18M03S  ; 17.75C;EA1=1880 soit 1.652V 


Header file excluded from package: C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.1.58/xc8/pic/include/pic18f27k42.h
Header file excluded from package: C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.1.58/xc8/pic/include/xc.h
Packaged project in C:\MPLABX_Projects\_18F27K42_OLED_SSD1306_2021-03.X\_18F27K42_OLED_SSD1306_2021-03.zip
Loading code from C:/MPLABX_Projects/_18F27K42_OLED_SSD1306_2021-03.X/dist/default/production/_18F27K42_OLED_SSD1306_2021-03.X.production.hex...
Loading completed

*/